/*****************************************************************************
    Ethernet packet sniffer - GreedyDog2

    Developed by Shadow Penguin Security Resarch Group
     http://www.shadowpenguin.org
     UNYUN <unyun@shadowpenguin.org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

 *****************************************************************************/

#include <stdio.h>
#include "depend.h"
#include "gui_win32_console.h"
#include "resource.h"

char        console_buffer[MAX_CNSOLEBUFSIZE];  /* console buffer */
int         now_p=0;                            /* console current pointer */
HWND        hWnd_Console=NULL;                  /* window handle of maindlg */

/*============================================================================
 write to console
 [INPUT]
    buf         : String buffer to write
 [RETURN]
    none
  ============================================================================
*/
void console_write(char *buf)
{
    int         j;

    if (hWnd_Console==NULL) return;

    while(now_p+strlen(buf)+1>=MAX_CNSOLEBUFSIZE){
        for (j=0;j<now_p;j++)
            if (console_buffer[j]=='\n') break;
        j++;
        now_p-=j;
        memcpy(console_buffer,console_buffer+j,now_p);
        console_buffer[now_p]=0;
    }
    strcat(console_buffer,buf);
    now_p+=strlen(buf);
    SetTimer(hWnd_Console,CONSOLE_TIMERID,100,NULL);
}

/*============================================================================
 display content of console
 [INPUT]
    none
 [RETURN]
    none
  ============================================================================
*/
void console_show(void)
{
    SetDlgItemText(hWnd_Console,IDC_CONSOLE,console_buffer);
    SendMessage(GetDlgItem(hWnd_Console,IDC_CONSOLE),WM_VSCROLL,
                (WPARAM)MAKEWORD(SB_BOTTOM,0),0);
}

/*============================================================================
 Initialize console
 [INPUT]
    hWnd            : Window handle
 [RETURN]
    none
  ============================================================================
*/
void console_initialize(HWND hWnd)
{
    strcpy(console_buffer,"");
    hWnd_Console=hWnd;
    now_p=0;
    SetDlgItemText(hWnd,IDC_CONSOLE,"");
}

