/*****************************************************************************
    Ethernet packet sniffer - GreedyDog2

    Developed by Shadow Penguin Security Resarch Group
     http://www.shadowpenguin.org
     UNYUN <unyun@shadowpenguin.org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    Thanks : rocket <rocket_z@dial.104.net> helped me to develop this code !
             hsj <hsj@shadowpenguin.org> told me the point to port this code
             to AIX.

 *****************************************************************************/

#include <unistd.h>
#include <stdio.h>
#include "depend.h"
#include "param.h"
#include "promisc.h"
#include "analyze.h"
#include "gddconfig.h"
#include "error.h"
#include "analyze.h"

/*============================================================================
 Main loop (read packet and analyze it)
 [INPUT]
  gddc          : Configuration data of gdd
 [RETURN]
  none
  ============================================================================
*/
void sniffloop(GDDCONFIG *gddc)
{
	static long             packet[CHUNKSIZE];
	static int              flag;
	struct strbuf           data;
	SOCKET                  sock;
	static long             ctlbuf[CHUNKSIZE];
	static struct strbuf    ctl = {CHUNKSIZE,0,(char *)ctlbuf};

	if (init_connection_table()){
		errorlog(ERRLOG_FATAL,"Can not initialize contable\n");
		return;
	}

	if ((sock=setnic_promisc(gddc->nit_dev,gddc->nic_name,NULL))<0){
		errorlog(ERRLOG_FATAL,"setnic_promisc error (%d)\n",sock);
		release_connection_table();
		return;
	}
	data.buf    = (char *)packet+2; /* "+2" : adjustment for RISC CPU */
	data.maxlen = (CHUNKSIZE/4)*4-4;
	data.len    = 0;
	for (;;){
		if(getmsg(sock,&ctl,&data,&flag)==0){
			if (packet_analysis(gddc,(void *)packet+2,data.len)){
				release_connection_table();
				return;
			}
			data.len = 0;
		}
	}
}
